ccd(4): Fix operator precedence.
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         UPGRADING DRAGONFLY FROM 3.0 to later versions                +
13 +-----------------------------------------------------------------------+
14
15 APIC_IO OPTION REMOVED
16 ----------------------
17
18 The APIC_IO kernel option is no longer accepted after having been without
19 effect for a while. The hw.ioapic_enable tunable now serves its purpose.
20 If you have 'options APIC_IO' in your kernel config, you'll have to
21 remove it.
22
23 WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
24 -----------------------------------------
25
26 The wdog framework is now compiled into our kernels by default, so the
27 options are no longer needed.
28
29 DOSCMD(1) REMOVED
30 -----------------
31
32 doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
33 NO_X make.conf option was removed too.
34
35 GCC 4.7
36 -------
37
38 GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
39 default compiler in base (default is still GCC 4.4).
40
41 Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
42 NO_GCC47 in /etc/make.conf.
43
44 USB4BSD
45 -------
46
47 A new USB stack (from FreeBSD) has been brought in. The following
48 modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
49 usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
50 and uaudio.
51
52 It is not yet the default. To activate it, WANT_USB4BSD=yes has to
53 be put in make.conf and device "usb4bsd" (quotes needed) has to
54 replace device usb in the kernel config. After that, a full
55 build/install/upgrade cycle is needed.
56
57 Note that this is experimental and incomplete, but we are interested
58 in hearing about issues with it, of course.
59
60 ISA SUPPORT REMOVED FROM AIC-6260/6360 DRIVER
61 ---------------------------------------------
62
63 ISA adapter support was dropped from the aic(4) driver.
64
65 +-----------------------------------------------------------------------+
66 +         UPGRADING DRAGONFLY FROM 2.10 to later versions               +
67 +-----------------------------------------------------------------------+
68
69 SEVERAL ISA DRIVERS REMOVED
70 ---------------------------
71
72 The following ISA only drivers have been removed along with a couple of
73 associated userland tools:
74
75 aha(4)
76 asc(4) & sasc(1)
77 ctx
78 dgb(4)
79 el(4)
80 gpib
81 gsc(4) & sgsc(1)
82 ie(4)
83 labpc(4)
84 le(4)
85 mse(4)
86 rc(4)
87 rdp(4)
88 spigot
89 tw(4) & xten(1) & xtend(8)
90 wl(4) & wlconfig(8)
91 wt(4)
92
93 Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
94 config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
95 file.
96
97 If buildkernel complains about any of these drivers, just remove them
98 from your kernel configuration.
99
100 BINUTILS 2.20
101 -------------
102 Binutils 2.20 has been removed in favor of Binutils 2.22.  The accepted
103 values of BINUTILSVERS are now binutils221 and binutils222 (default).
104
105 BUILDWORLD/-KERNEL PARALLELIZATION WORK
106 ---------------------------------------
107 Due to changes in the way we build with more than one make job, you
108 will have to update install(1) and mkdir(1) prior to buildworld if you
109 want to build with 'make -j':
110
111 cd /usr/src/usr.bin/xinstall; make; make install; make clean
112 cd /usr/src/bin/mkdir; make; make install; make clean
113
114 DMA(8) UPGRADE
115 --------------
116 dma(8) has been upgraded to v0.7 which no longer supports the
117 /etc/dma/virtusertable. Some of its functionality has been replaced
118 with the MASQUERADE keyword and the EMAIL environment variable (see
119 the dma(8) manual page).
120
121 +-----------------------------------------------------------------------+
122 +         UPGRADING DRAGONFLY FROM 2.8 to later versions                +
123 +-----------------------------------------------------------------------+
124
125 GCC 4.4 & BINUTILS 2.21
126 -----------------------
127
128 GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
129 been made DragonFly's default Binutils.
130
131 That means that any settings that set CCVER to 'gcc44' are not needed
132 anymore. Instead, CCVER can be set to 'gcc41' to go back to using
133 GCC 4.1.
134
135 It also means that 'binutils221' as a value for BINUTILSVER has no
136 effect anymore. 2.17 has been removed and 'binutils220' is available
137 as an option.
138
139 The NO_GCC44 option has been removed and will not affect the build
140 anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
141 building in a similar fashion.
142
143 Note that you must do a full buildworld/buildkernel for upgrading.
144
145 pkg_radd settings
146 -----------------
147
148 The config file for pkg_radd has moved from /etc/settings.conf to 
149 /etc/pkg_radd.conf.  Save the contents of settings.conf before upgrading
150 if this is needed.  This warning only applies if /etc/settings.conf 
151 exists.  pkg_radd will continue to work with defaults.
152
153 +-----------------------------------------------------------------------+
154 +         20100927                                                      +
155 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
156 +-----------------------------------------------------------------------+
157
158 OpenSSL
159 --------
160
161 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
162 This shouldn't break any 3rd-party software, but you'll need to recompile your
163 3rd-party software if you want it to link against the new version of OpenSSL.
164
165 Loader
166 -------
167
168 A new loader (dloader) has been added which better handles booting from
169 multiple kernel/module versions.
170
171 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
172
173         cd /usr/src
174         make buildworld
175         make installworld
176         make upgrade
177         make buildkernel KERNCONF=<KERNELNAME>
178         make installkernel KERNCONF=<KERNELNAME>
179
180 Note that you must installworld and run the 'upgrade' target before
181 installing the new kernel.
182
183 BIND
184 -----
185
186 BIND has been removed from the base system.  The ldns and drill tools have 
187 been added for basic functionality.  Use 'drill' where you would normally 
188 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
189 net/bind95, net/bind96, or net/bind97 as of this writing.
190
191 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
192 include BIND as a pkgsrc package.
193
194 +-----------------------------------------------------------------------+
195 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
196 +                               GENERAL                                 +
197 +-----------------------------------------------------------------------+
198
199 Instructions on how to obtain and maintain DragonFly source code using git
200 are in the development(7) manual page.
201
202 To upgrade a DragonFly system from sources you run the following sequence:
203
204         cd /usr/src
205         make buildworld
206         make buildkernel KERNCONF=<KERNELNAME>
207         make installkernel KERNCONF=<KERNELNAME>
208         make installworld
209
210 You will also want to run the 'upgrade' target to upgrade your /etc and the
211 rest of your system.  The upgrade target is aware of stale files created by
212 older DragonFly installations and should delete them automatically.
213
214         make upgrade
215
216 See the build(7) manual page for further information.
217
218 Once you've done a full build of the world and kernel you can do incremental
219 upgrades of either by using the 'quickworld' and 'quickkernel' targets
220 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
221 the quick targets, try updating your repo first, and then a full buildworld
222 and buildkernel as shown above, before asking for help.
223
224 +-----------------------------------------------------------------------+
225 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
226 +-----------------------------------------------------------------------+
227
228 In 2.1 kernel and modules has moved to boot directory.  For most cases
229 this is handled automatically by 'make upgrade'.  A few cases needs manual
230 intervention:
231
232  * When installing a kernel without first doing a make buildworld,
233    installworld and upgrade to the same DESTDIR as kernel:
234    make DESTDIR/boot directory and move kernel and modules into this boot
235    directory; also move kernel.old and modules.old.
236    Typical example is vkernel(7), use (no modules used):
237
238         cd /var/vkernel
239         mkdir boot
240         chflags noschg kernel
241         mv kernel kernel.old boot
242         chflags schg boot/kernel
243         
244  * When using a boot-only partition, /boot/loader.rc needs to be edited:
245    delete occurrences of '/boot/'.
246    These occurences can normally be deleted in any case, see loader(8).
247
248 +-----------------------------------------------------------------------+
249 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
250 +-----------------------------------------------------------------------+
251
252 In 1.9 major changes to the disk management infrastructure have taken
253 place.  make upgrade may not catch all of your disk devices in /dev,
254 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
255 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
256 and MAKEDEV no longer exists.
257
258 The biggest changes in 1.9 are:
259
260 (1) That whole-slice devices such as da0s1 no longer share the same device
261     id as partition c devices such as da0s1c.
262
263 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
264     with no snooping or reserved sectors.  Consequently you cannot run
265     disklabel on this device.  Instead you must run disklabel on a
266     whole-slice device.
267
268 (3) The 'compatibility' partitions now use slice 0 in the device name,
269     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
270     accessing the disklabel for the compatibility partitions must be
271     done via slice 0 (da0s0).
272
273 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
274     and CCD now run through the disk management layer and are assigned
275     real disk management devices.   VN and CCD in particular do not usually
276     use a MBR and disklabels must be accessed through the compatibility
277     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
278     don't name it 'ccd0s0' in the config file.
279
280 Generally speaking, you have to get used to running fdisk and disklabel on
281 the correctly specified device names.  A lot of the wiggle, such as running
282 disklabel on a partition, has been removed.
283
284 +-----------------------------------------------------------------------+
285 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
286 +-----------------------------------------------------------------------+
287
288 > Kerberos IV
289 -------------
290
291 Kerberos IV (eBones) was removed from the tree, please consider moving to
292 Kerberos 5 (Heimdal).
293
294 > Package Management System
295 ---------------------------
296
297 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
298 management system.  The necessary tools to build and maintain packages
299 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
300 directories are in your PATH variable.
301
302 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
303 the tarball from NetBSD:
304
305         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
306         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
307
308 This tree can then be kept up to date with cvs update:
309
310         cd /usr/pkgsrc; cvs up
311
312 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
313 build and install the pkgsrc bootstrap manually:
314
315         cd /usr/pkgsrc/bootstrap
316         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
317
318 +-----------------------------------------------------------------------+
319 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
320 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
321 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
322 +-----------------------------------------------------------------------+
323
324 The compatibility shims for the build environment have been removed, you
325 have to update to DragonFly 1.2 release branch first.
326
327 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
328 The existing configuration can be converted using /etc/pam.d/convert.sh.
329 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
330 the pam_skey.so module was retired, you have to remove it manually from
331 your configuration, when you convert it.
332
333 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
334 ---------------------
335
336 The following users may be missing from your password file.  Use vipw and
337 add any that are missing:
338
339 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
340 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
341
342 The following groups may be missing from your group file.  Use vi /etc/group
343 and add any that are missing:
344
345 smmsp:*:25:
346 authpf:*:63:
347 _pflogd:*:64:
348
349
350 > Upgrading to DragonFly from FreeBSD
351 ---------------------
352
353 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
354 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
355 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
356 make depend information, it starts from scratch, so no pre-cleaning of the
357 object hierarchy is necessary.
358
359         # get the CVS repository (it is placed in /home/dcvs, 500MB).
360         # Please use the -h option and a mirror site to pull the 
361         # initial repository, but feel free to use the main repository
362         # machine to pull updates.
363         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
364         # install the source from the CVS hierarchy (remove preexisting
365         # FreeBSD src first) (500MB)
366         cd /usr
367         rm -rf src
368         cvs -R -d /home/dcvs checkout -P src
369
370         # build it (500MB used in /usr/obj)
371         #
372         cd /usr/src
373         make buildworld
374         make buildkernel KERNCONF=<KERNELNAME>
375
376 Once you have built DragonFly you have to install it over FreeBSD.  Since
377 DragonFly does not track changes made by FreeBSD to its include file 
378 hierarchy and include file pollution can cause all sorts of unexpected
379 compilation issues to come up, it is best to wipe your include hierarchy
380 prior to installing DragonFly.  Note that you should not wipe any installed
381 FreeBSD header files or binaries until after you have successfully completed
382 the build steps above.
383
384         rm -rf /usr/include
385         mkdir /usr/include
386         make installkernel KERNCONF=<KERNELNAME>
387         make installworld
388
389 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
390 will unconditionally upgrade the /etc files that sysops do not usually
391 mess around with, such as the files in /etc/rc.d.  It will also remove any
392 obsolete files such as utilities and manpages that have been removed from
393 the system since the version you're coming from.  If you are unsure we 
394 recommend that you make a backup of at least your /etc before applying
395 this step.  Note that DragonFly's RC system is basically RCNG from
396 FreeBSD-5, but there are some differences in the contents of the RC files.
397
398         make upgrade
399
400 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
401 Doing so might leave your system in an unusable state.
402
403 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
404 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
405 report these files to the DragonFly developers so that they can be added to
406 the 'upgrade' target.
407